// C Source File
// Created 12/25/00; 7:52:07 PM

#define OPTIMIZE_ROM_CALLS    // Use ROM Call Optimization

#define SAVE_SCREEN           // Save/Restore LCD Contents
#define YOU	0
#define WUMPUS	1
#define PIT1	2
#define PIT2	3
#define BATS1	4
#define BATS2	5
#define LOCS	6
#define NOT	0
#define WIN	1
#define LOSE	-1
#define BUFSIZ 10
// #define DEBUG 1 // If this is defined, the location of the wumpus will be revealed
								// at program start, along with the location of bats and pits

#include <tigcclib.h>         // Include All Header Files

short _ti89;                  // Produce .89Z File

static int path[5];

static int j, k, arrows, scratchloc;
static char inp[BUFSIZ];		/* common input buffer */


static int loc[LOCS], save[LOCS];	/* locations */


static int finished;

static int cave[20][3] =
{
    {1,4,7},
    {0,2,9},
    {1,3,11},
    {2,4,13},
    {0,3,5},
    {4,6,14},
    {5,7,16},
    {0,6,8},
    {7,9,17},
    {1,8,10},
    {9,11,18},
    {2,10,12},
    {11,13,19},
    {3,12,14},
    {5,13,15},
    {14,16,19},
    {6,15,17},
    {8,16,18},
    {10,17,19},
    {12,15,18},
};

#define FNA() (rand() % 20) 

#define FNB() (rand() % 3) 

#define FNC() (rand() % 4) 

int getnum(prompt)
char *prompt;
{
    (void) printf("%s\n?", prompt);
    (void) gets(inp);
    return(atoi(inp));
}

int getlet(prompt)
char *prompt;
{
    (void) printf("%s\n?", prompt);
    (void) gets(inp);
    if (strlen(inp) == 0)
    {
    		puts("REALLY, QUIT?");
    		(void) gets(inp);
    		if (inp[0] == 'Y')
    			exit(0);
    		else
    			return(0);
    }
    return(inp[0]);    
}

void title_screen()
{
	ClrScr();
	printf ("HUNT THE WUMPUS\n");
	printf("\n\nPORTED TO TI89\nBY JAMES TRIMBLE\n");
	printf("VERSION 1.0\n");
	printf("DISTRIBUTED UNDER\nTHE GNU GPL\n");
	printf("WITHOUT WARRANTY\n");
	ngetchx();
}
void print_instructions()
{
		//		 "--------SCREEN SIZE-------"
		ClrScr();
		
    puts("WELCOME TO \n");
    puts("'HUNT THE WUMPUS'\n\n");
    puts("THE WUMPUS LIVES IN A CAVE\n");
    puts("OF 20 ROOMS. EACH ROOM\n");
    puts("HAS 3 TUNNELS LEADING TO \n");
    puts("OTHER ROOMS. (LOOK AT A\n");
    puts("DODECAHEDRON TO SEE HOW\n");
    puts("THIS WORKS -IF YOU DON'T\n");
    puts("KNOW WHAT A DODECAHEDRON\n");
    puts("IS, ASK SOMEONE)");
    
    ngetchx();
    ClrScr();
    putchar('\n');
 
    puts("HAZARDS:\n");
    puts("BOTTOMLESS PITS - TWO\n");
    puts("ROOMS HAVE BOTTOMLESS PITS\n");
    puts("IN THEM. IF YOU GO THERE,\n");
    puts("YOU FALL INTO THE PIT\n");
    puts("SUPER BATS - TWO OTHER\n");
    puts("ROOMS HAVE SUPER BATS.\n");
    puts("IF YOU GO THERE, A BAT\n");
    puts("GRABS YOU AND TAKES YOU TO\n");
    puts("SOME OTHER ROOM AT RANDOM.\n");
    puts("(WHICH MAY BE TROUBLESOME)");
    
    ngetchx();
    ClrScr();
    putchar('\n');
    
    puts("WUMPUS:\n");
    puts("THE WUMPUS IS NOT BOTHERED\n");
    puts("BY HAZARDS (HE HAS SUCKER\n");
    puts("FEET AND IS TOO BIG FOR A \n");
    puts("BAT TO LIFT).  USUALLY HE\n");
    puts("IS ASLEEP.  TWO THINGS\n");
    puts("WAKE HIM UP: YOU SHOOTING\n");
    puts("AN ARROW OR YOU ENTERING\n");
    puts("HIS ROOM.\n");
    
    ngetchx();
    ClrScr();
    putchar('\n');
    
    puts("IF THE WUMPUS WAKES HE\n");
    puts("MOVES (P=.75) ONE ROOM OR\n");
    puts("STAYS STILL (P=.25). AFTER\n");
    puts("THAT, IF HE IS WHERE YOU\n");
    puts("ARE, HE EATS YOU UP AND\nYOU LOSE!\n");

    ngetchx();
    ClrScr();
    putchar('\n');
        
    puts("YOU:\n");
    puts("EACH TURN YOU MAY MOVE OR\n");
    puts("SHOOT A CROOKED ARROW\n\n");
    puts("MOVING: YOU CAN MOVE ONE\n");
    puts("ROOM (THRU ONE TUNNEL)\n\n");
    puts("ARROWS: YOU HAVE 5 ARROWS.\n");
    puts("YOU LOSE WHEN YOU RUN OUT.\n");
    puts("EACH ARROW CAN GO FROM 1\n");
    puts("TO 5 ROOMS.");
    
    ngetchx();
		ClrScr();
    putchar('\n');
    
    puts("YOU AIM BY TELLING\n");
    puts("THE COMPUTER THE ROOM #'S\n");
    puts("YOU WANT THE ARROW TO GO\n");
    puts("TO. IF THE ARROW CAN'T GO\n");
    puts("THAT WAY (IF NO TUNNEL) IT\n");
    puts("MOVES AT RANDOM TO THE\nNEXT ");
    puts("ROOM. IF THE ARROW\n HITS THE ");
    puts("WUMPUS, YOU WIN.\n");
    puts("IF THE ARROW HITS YOU,\n");
		puts("YOU LOSE.\n");
		
    ngetchx();
    ClrScr();
    putchar('\n');
        
    puts("WARNINGS:\n\n");
    puts("WHEN YOU ARE ONE ROOM AWAY\n");
    puts("FROM A WUMPUS OR HAZARD,\n");
    puts("THE COMPUTER SAYS:\n\n");
    puts("WUMPUS: 'I SMELL A WUMPUS'\n\n");
    puts("BAT   : 'BATS NEARBY'\n\n");
    puts("PIT   : 'I FEEL A DRAFT'");
    ngetchx();
    ClrScr();

}

void check_hazards()
{
    (void) puts("");
    for (k = 0; k < 3; k++)
    {
	int room = cave[loc[YOU]][k];

	if (room == loc[WUMPUS])
	{
	    (void) puts("I SMELL A WUMPUS!");
			puts("\n");
	}
	else if (room == loc[PIT1] || room == loc[PIT2])
	{
	    (void) puts("I FEEL A DRAFT");
			puts("\n");
	}
	else if (room == loc[BATS1] || room == loc[BATS2])
	{
	    (void) puts("BATS NEARBY!");
  		puts("\n");
  }
  
    }

   
    (void) printf("YOU ARE IN ROOM %d\n", loc[YOU]+1);

    
    (void) printf("TUNNELS LEAD TO %d %d %d\n",
		  cave[loc[YOU]][0]+1, cave[loc[YOU]][1]+1, cave[loc[YOU]][2]+1);

  
    (void) puts("");

 
}

int move_or_shoot()
{
    int c;


badin:
    c = getlet("SHOOT OR MOVE (S-M)");

    if (c == 'S')
	return(1);
    else if (c == 'M')
	return(0);
    else
	goto badin;
	ClrScr();
}



void shoot()
{
    extern void check_shot(), move_wumpus();
    int	j9;

    finished = NOT;

badrange:
    j9 = getnum("NO. OF ROOMS (1-5)");

    if (j9 < 1 || j9 > 5)
	goto badrange;

    for (k = 0; k < j9; k++)
    {
	path[k] = getnum("ROOM #") - 1;

	if (k <= 1)
	    continue;


	if (path[k] != path[k - 2])
	    continue;


	(void) puts("ARROWS AREN'T THAT CROOKED\n - TRY ANOTHER ROOM\n");

	k--;


    }


    scratchloc = loc[YOU];


    for (k = 0; k < j9; k++)
    {
	int	k1;


	for (k1 = 0; k1 < 3; k1++)
	{

	    if (cave[scratchloc][k1] == path[k])
	    {
		
		scratchloc = path[k];

	
		check_shot();
		if (finished != NOT)
		    return;
	    }

	    
	}


	scratchloc = cave[scratchloc][FNB()];

	
	check_shot();

	
    }

ammo:
    if (finished == NOT)
    {
	
	(void) puts("MISSED\n");

	
	scratchloc = loc[YOU];

	
	move_wumpus();

	
	if (--arrows <= 0)
	    finished = LOSE;
    }

    
}

void check_shot()
{
    
    if (scratchloc == loc[WUMPUS])
    {
	(void) puts("AHA! YOU GOT THE WUMPUS!\n");
	finished = WIN;
    }

    
    else if (scratchloc == loc[YOU])
    {
	(void) puts("OUCH! ARROW GOT YOU!\n");
	finished = LOSE;
    }
}

void move_wumpus()
{
    
    k = FNC();

    
    if (k < 3)
	loc[WUMPUS] = cave[loc[WUMPUS]][k];

   
	return;

    (void) puts("TSK TSK TSK\nWUMPUS GOT YOU!\n");

    
    finished = LOSE;

    
}

void move()
{
    
    finished = NOT;

badmove:
    
    scratchloc = getnum("WHERE TO");

    
    if (scratchloc < 1 || scratchloc > 20)
	goto badmove;
    scratchloc--;

    
    for (k = 0; k < 3; k++)
    {
	
	if (cave[loc[YOU]][k] == scratchloc)
	    goto goodmove;

	
    }

    
    if (scratchloc != loc[YOU])
    {

	(void) puts("NOT POSSIBLE -");


	goto badmove;
    }

goodmove:
    
    loc[YOU] = scratchloc;

    if (scratchloc == loc[WUMPUS])
    {
	
	(void) puts("... OOPS! BUMPED A WUMPUS!\n");
	move_wumpus();
    }
    else if (scratchloc == loc[PIT1] || scratchloc == loc[PIT2])
    {

	(void) puts("YYYYIIIIEEEE . . . \nFELL IN PIT!\n");
	finished = LOSE;
    }
    else if (scratchloc == loc[BATS1] || scratchloc == loc[BATS2])
    {

	(void) puts("ZAP--SUPER BAT SNATCH!\nELSEWHEREVILLE FOR YOU!\n");
	scratchloc = loc[YOU] = FNA();
	goto goodmove;
    }
}

void _main(void)
{
    int	c;
	title_screen();
	ClrScr();
   
    c = getlet("INSTRUCTIONS (Y-N)");

    
    if (c == 'Y')
	print_instructions();
	ClrScr();

  
badlocs:
   
    for (j = 0; j < LOCS; j++)
	loc[j] = save[j] = FNA();

    
    
    
    
    
    
    
    for (j = 0; j < LOCS; j++)
	for (k = 0; k < LOCS; k++)
	    if (j == k)
		continue;
    	    else if (loc[j] == loc[k])
		goto badlocs;

    
newgame:    
    
    
    arrows = 5;
    scratchloc = loc[YOU];

    ClrScr();
    
    (void) puts("\nHUNT THE WUMPUS\n");

#ifdef DEBUG
    (void) printf("Wumpus is at %d, pits at %d & %d, bats at %d & %d\n",
		  loc[WUMPUS]+1,
		  loc[PIT1]+1, loc[PIT2]+1,
		  loc[BATS1]+1, loc[BATS2]+1);
#endif

nextmove:    
    
    
    check_hazards();

    
    
    
    if (move_or_shoot())
    {
	
	
	shoot();

	
	if (finished == NOT)
	    goto nextmove;

	
    }
    else
    {
	
	
	move();

	
	if (finished == NOT)
	    goto nextmove;
    }

    
    if (finished == LOSE)
    {
	
	
	
	(void) puts("HA HA HA - YOU LOSE!");
    }
    else
    {
	
	
	(void) puts("HEE HEE HEE\nTHE WUMPUS'LL GET \nYOU NEXT TIME!!\n");
    }

    
    for (j = YOU; j < LOCS; j++)
	loc[j] = save[j];

    
    c = getlet("\nSAME SETUP (Y-N)");

  
    if (c != 'Y')
	goto badlocs;
    else
	goto newgame;
}


